/*!
 * MIT License
 *
 * Copyright (c) 2020 Michael Marcenich
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
var WorkboxPluginFirebaseAuth=function(){"use strict";function t(t,e,s,i){return new(s||(s=Promise))((function(n,r){function o(t){try{c(i.next(t))}catch(t){r(t)}}function a(t){try{c(i.throw(t))}catch(t){r(t)}}function c(t){var e;t.done?n(t.value):(e=t.value,e instanceof s?e:new s((function(t){t(e)}))).then(o,a)}c((i=i.apply(t,e||[])).next())}))}return class{constructor(e={}){this.requestWillFetch=({request:e})=>t(this,void 0,void 0,(function*(){if(!this.awaitResponse||!this.shouldAuthorizeRequest(e))return e;const t=yield this.getIdToken();return t?this.authorizeRequest(e,t):e})),this.fetchDidSucceed=({request:e,response:s})=>t(this,void 0,void 0,(function*(){if(this.awaitResponse||401!==s.status||!this.shouldAuthorizeRequest(e))return s;const t=yield this.getIdToken();if(!t)return s;const i=yield this.authorizeRequest(e,t);return fetch(i)})),this.awaitResponse=e.awaitResponse||!1;const{types:s,https:i,ignorePaths:n}=e.constraints||{};this.constraints={types:"string"==typeof s?[s]:s||["*"],https:!!i,ignorePaths:n||[]};const r=Object.assign({version:"7.14.2"},e.firebase);r.config?(importScripts(`https://www.gstatic.com/firebasejs/${r.version}/firebase-app.js`),importScripts(`https://www.gstatic.com/firebasejs/${r.version}/firebase-auth.js`),firebase.initializeApp(r.config)):(importScripts(`/__/firebase/${r.version}/firebase-app.js`),importScripts(`/__/firebase/${r.version}/firebase-auth.js`),importScripts("/__/firebase/init.js")),this.auth=firebase.auth()}getIdToken(){return t(this,void 0,void 0,(function*(){return new Promise(t=>{const e=this.auth.onAuthStateChanged(s=>{e(),s?s.getIdToken(!0).then(e=>{t(e)},()=>{t(null)}):t(null)})})}))}authorizeRequest(e,s){return t(this,void 0,void 0,(function*(){const t=new Headers;e.headers.forEach((e,s)=>{t.append(s,e)}),t.append("Authorization","Bearer "+s);const i=e.clone(),{url:n}=i,r=function(t,e){var s={};for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&e.indexOf(i)<0&&(s[i]=t[i]);if(null!=t&&"function"==typeof Object.getOwnPropertySymbols){var n=0;for(i=Object.getOwnPropertySymbols(t);n<i.length;n++)e.indexOf(i[n])<0&&Object.prototype.propertyIsEnumerable.call(t,i[n])&&(s[i[n]]=t[i[n]])}return s}(i,["url"]);return new Request(n,Object.assign(Object.assign({},r),{mode:"same-origin",redirect:"manual",headers:t}))}))}shouldAuthorizeRequest(t){const e=new URL(t.url),s=self.location.origin===e.origin,i=this.hasCorrectType(t.headers.get("accept")),n=!this.constraints.https||"https:"===self.location.protocol||"localhost"===self.location.hostname,r=!this.constraints.ignorePaths||this.constraints.ignorePaths.some(t=>"string"==typeof t?e.pathname.startsWith(t):t.test(e.pathname));return s&&i&&n&&!r}hasCorrectType(t){const e=this.constraints.types,s=t&&t.split(",").map(t=>t.split(";")[0].trim());return!e||e.includes("*")||!s||s.some(t=>e.includes(t))}}}();
